	includeh	quickdraw.def	*Defintion files we use
	includeh	palettes.def
	includeh	windows.def
	includeh	memory.def
	includeh	resources.def
	includeh	quickdrawtext.def
	includeh	OSUtils.def
	includeh	general_usage.def
***************************************************
*Clut fade test program
*Sets monitor to 256 or quits before starting
*(C) Lightsoft 96
***************************************************
Clut_Fade:
	ENTRY
	start_up
	bl	init_mac	*lib function

**first check depth
	Xcall	GetMainDevice	*return GDhandle in r3
	stw	r3,main_device_h(`bss)	*Store the main graphics device handle
	lwz	r3,(r3)				*handle
	lwz	r3,GdPMap(r3)		*pointer to pixmap
	lwz	r3,(r3)				*pointer to pixmap
	lhz	r3,PizelSize(r3)	*The current bit depth
	sth	r3,initial_depth(`bss)
**Check device can do 8 bit graphics
	lwz	r3,main_device_h(`bss)
	li	r4,8	*we want to know if 8 bit is possible
	li	r5,0	*whichflags
	li	r6,1	*colour...
	Xcall	HasDepth	*returns either 0 or mode word in r3
	cmpwi	r3,0
	beq	no_8_bit_possible
	
**If yes, then set depth to 8 bit
	lwz	r3,main_device_h(`bss)
	li	r4,8	*we want 8 bit
	li	r5,0	*whichflags
	li	r6,1	*colour...
	Xcall	SetDepth	*returns either 0 or bad!
	cmpwi	r3,NoErr
	bne	no_8_bit_possible

*********Now we're in 8 bit mode
	bl	open_window	*in utilities - sets port as well.
	bl	copy_active_clut	*so we can restore it

	li	r3,30
	bl	fade_down

	li	r3,128
	bl	load_clut	*load clut 128 from res fork, returns r3=handle
	stw	r3,res_clut(`bss)

	li	r3,129
	bl	load_clut	*load clut 129 from res fork, returns r3=handle
	stw	r3,res_clut_green(`bss)

	li	r3,130
	bl	load_clut	*load clut 130 from res fork, returns r3=handle
	stw	r3,res_clut_rainbow(`bss)

	

	li	r3,30
	li	r4,0xffff	*yellow
	li	r5,0xffff
	li	r6,0
	bl	fade_to_colour

	li	r3,30
	li	r4,0x0	*green
	li	r5,0xffff
	li	r6,0x0
	bl	fade_to_colour


	li	r3,30
	li	r4,0xffff	*purple
	li	r5,0
	li	r6,0xffff
	bl	fade_to_colour

	li	r3,30
	li	r4,0xffff	*white
	li	r5,0xffff
	li	r6,0xffff
	bl	fade_to_colour

	li	r3,128		*fade down over 64 steps (max halfword size)
	bl	fade_down	*in fade.s

**draw some h_lines
	bl	fill_lines	*in utilities - color 1, color 2, color 3 etc for window v size

**reset clut		
	lwz	r3,res_clut(`bss)
	lwz	r3,(r3)	*the red clut from resource s'il vous plait
	bl	splat_clut	*make it active ......NOW!

**now lets rotate that clut!
**we need an array of max_colours*8 for the copy of the clut

	li	r3,max_colours*4*half+20	*we need all four words for this	
	Xcall	NewHandle		*+20 cause I'm paranoid
	cmpwi	r3,zero
	beq	cant_rotate
	stw	r3,temp_clut_h(`bss)

	lwz	r3,res_clut(`bss)
	lwz	r3,(r3)
	lwz	r4,temp_clut_h(`bss)
	lwz	r4,(r4)
	bl	copy_clut		*copy red to temp so we can mess it about

**now lets rotate our copy of the red clut
	bl	do_rotate
	li	r3,100
	bl	fade_down
	
**draw some h_lines
	bl	fill_v_lines	*in utilities - color 1, color 2, color 3 etc for window v size
	li	r3,150
	lwz	r4,res_clut(`bss)
	bl	fade_to_clut	
**now lets do multicolor rotates
	lwz	r3,current_clut_h(`bss)
	lwz	r3,(r3)
	lwz	r4,temp_clut_h(`bss)
	lwz	r4,(r4)
	bl	copy_clut		*copy red to temp so we can mess it about

**now lets rotate our copy of the red clut
	bl	do_rotate
	li	r3,150
	lwz	r4,res_clut_green(`bss)
	bl	fade_to_clut	

	li	r3,150
	lwz	r4,res_clut(`bss)
	bl	fade_to_clut	

	li	r3,150
	lwz	r4,res_clut_rainbow(`bss)
	bl	fade_to_clut	


**********************************************
**Now, we just have to do the circles :-)
	li	r3,100
	bl	fade_down
	bl	draw_circles	*draw a zoomy circle in red.
	lwz	r3,res_clut_green(`bss)
	lwz	r3,(r3)
	lwz	r4,temp_clut_h(`bss)
	lwz	r4,(r4)
	bl	copy_clut		*copy red to temp so we can mess it about

**now lets rotate our copy of the red clut
	bl	do_rotate1

cant_rotate:
**Finally, restore the system clut as it was before we started
	bl	show_copyright

	li	r3,600
	bl	fade_down
test:	
	lwz	r3,demo_window_ptr(`bss)
	Xcall	HideWindow

	lwz	r3,bg_window_ptr(`bss)
	Xcall	HideWindow

	
*********Clean up before exiting
restore_bit_depth:
	lwz	r3,main_device_h(`bss)
	lhz	r4,initial_depth(`bss)	*set back to depth before we ran
	li	r5,0	*whichflags
	li	r6,1	*colour...
	Xcall	SetDepth	*returns either 0 or bad!

	lwz	r3,current_clut_h(`bss)
	lwz	r3,(r3)	*the clut on startup
	bl	splat_clut

no_8_bit_possible:
	tidy_up
	blr
**minor routines
do_rotate:
	mflr	r29
	li	r5,500			*rotate 1100 times
	stw	r5,rotate_counter(`bss)
rot_loop:
	lwz	r3,temp_clut_h(`bss)
	lwz	r3,(r3)	*the clut on startup
	bl	rotate_clut		*and shift
	lwz	r3,temp_clut_h(`bss)
	lwz	r3,(r3)	
	bl	splat_clut		*and splat and...
	lwz	r5,rotate_counter(`bss)
	subi	r5,r5,1
	stw	r5,rotate_counter(`bss)
	cmpwi	r5,300
	bne	not_text
	bl	print_text
	lwz	r5,rotate_counter(`bss)
not_text:
	cmpwi	r5,0
	bne	rot_loop
	mtlr	r29	
	blr
**End of of clut rotate	

**minor routines
do_rotate1:
	mflr	r29
	li	r5,1100			*rotate 1100 times
	stw	r5,rotate_counter(`bss)
rot_loop1:
	lwz	r3,temp_clut_h(`bss)
	lwz	r3,(r3)	*the clut on startup
	bl	rotate_clut		*and shift
	lwz	r3,temp_clut_h(`bss)
	lwz	r3,(r3)	
	bl	splat_clut		*and splat and...
	lwz	r5,rotate_counter(`bss)
	subi	r5,r5,1
	stw	r5,rotate_counter(`bss)
	cmpwi	r5,600
	bne	not_text1
	bl	print_text1
	lwz	r3,res_clut_rainbow(`bss)
	lwz	r3,(r3)
	lwz	r4,temp_clut_h(`bss)
	lwz	r4,(r4)
	bl	copy_clut		*copy red to temp so we can mess it about

	lwz	r5,rotate_counter(`bss)
not_text1:
	cmpwi	r5,0
	bne	rot_loop1
	mtlr	r29	
	blr
**End of of clut rotate	

;fred:	dc.h	1,2,3
;dummy:	dc.h	1		

***************************************************
	global	Clut_Fade
	extern	init_mac,open_window,fade_down,fade_to_colour,copy_active_clut,splat_clut
	extern	copy_clut,rotate_clut,load_clut,show_copyright
	extern	fill_lines,fill_v_lines,print_text,draw_circles,print_text1
	extern	fade_to_clut