	includeh	quickdraw.def	*Defintion files we use
	includeh	memory.def
	includeh	resources.def

*********************************************************
*Fade.s - various clut fade routines
**takes number of steps in r3
**(C) Lightsoft 96/97
fade_down:
	mflr	r29
	sth	r3,fade_steps(`bss)	*save the number of steps away for now
**we need an array of max_colours*6 for the fade values
	li	r3,max_colours*3*half+20	*we need rgb for each entry
	Xcall	NewHandle
	cmpwi	r3,zero
	beq	fade_down_fail
	stw	r3,fade_values_h(`bss)

**we need an array of max_colours*6 for the copy of the clut
	li	r3,max_colours*4*half+20	*we need all four words for this	
	Xcall	NewHandle		*+20 cause I'm paranoid
	cmpwi	r3,zero
	beq	fade_down_fail
	stw	r3,clut_copy_h(`bss)

**get r3=current table - each entry is 4 halfs
	bl	get_current_PmTable	*returns r3 pointing to Gdevice PmTable
**now calc fade values array
	bl	calc_fades	*in fade_values_h

	bl	run_fade
	lwz	r3,fade_values_h(`bss)
	Xcall	DisposeHandle
	lwz	r3,clut_copy_h(`bss)
	Xcall	DisposeHandle			
			
fade_down_all_ok:
	li	r3,0
	mtlr	r29
	blr
fade_down_fail:
	li	r3,-1
	mtlr	r29
	blr
************************************************************
**Fade_to_clut
* - takes number of steps in r3 and a clut to fade to in r4
fade_to_clut:
	mflr	r29
	sth	r3,fade_steps(`bss)	*save the number of steps away for now
	stw	r4,clut_to_fade_to(`bss)
**we need an array of max_colours*6 for the fade values
	li	r3,max_colours*3*half+20	*we need rgb for each entry
	Xcall	NewHandle
	cmpwi	r3,zero
	beq	ftc_fail
	stw	r3,fade_values_h(`bss)

**we need an array of max_colours*6 for the copy of the clut
	li	r3,max_colours*4*half+20	*we need all four words for this	
	Xcall	NewHandle		*+20 cause I'm paranoid
	cmpwi	r3,zero
	beq	ftc_fail
	stw	r3,clut_copy_h(`bss)

**get r3=current table - each entry is 4 halfs
	bl	get_current_PmTable	*returns r3 pointing to Gdevice PmTable
**now calc fade values array
	bl	calc_fades_clut	*in fade_values_h

	bl	run_fade_add	*same as run fade but adds rather than subtracts
	lwz	r3,fade_values_h(`bss)
	Xcall	DisposeHandle
	lwz	r3,clut_copy_h(`bss)
	Xcall	DisposeHandle			
			
ftc_all_ok:
	li	r3,0
	mtlr	r29
	blr
ftc_fail:
	li	r3,-1
	mtlr	r29
	blr

************************************************************
**Needs number of steps in r3, red value in r4, green value in r5 and blue in r6
fade_to_colour:
	mflr	r29
	sth	r3,fade_steps(`bss)	*save the number of steps away for now
	sth	r4,fade_to_red(`bss)	*save the colour to fade to.
	sth	r5,fade_to_green(`bss)	
	sth	r6,fade_to_blue(`bss)	

**we need an array of max_colours*6 for the fade values
	li	r3,max_colours*3*half+20	*we need rgb for each entry
	Xcall	NewHandle
	cmpwi	r3,zero
	beq	fade_down_fail
	stw	r3,fade_values_h(`bss)

**we need an array of max_colours*6 for the copy of the clut
	li	r3,max_colours*4*half+20	*we need all four words for this	
	Xcall	NewHandle		*+20 cause I'm paranoid
	cmpwi	r3,zero
	beq	fade_tc_fail
	stw	r3,clut_copy_h(`bss)

**get r3=current table - each entry is 4 halfs
	bl	get_current_PmTable	*returns r3 pointing to Gdevice PmTable
**now calc fade values array
	bl	calc_fades_colour

	bl	run_fade
	lwz	r3,fade_values_h(`bss)
	Xcall	DisposeHandle
	lwz	r3,clut_copy_h(`bss)
	Xcall	DisposeHandle			
fade_tc_ok:
	li	r3,0
	mtlr	r29
	blr
fade_tc_fail:
	li	r3,-1
	mtlr	r29
	blr

************************************************************
**Copy_clut - copy the current GDevices clut
copy_active_clut:
	mflr	r29
**we need an array of max_colours*8 for the copy of the clut
	li	r3,max_colours*4*half+20	*we need all four words for this	
	Xcall	NewHandle		*+20 cause I'm paranoid
	cmpwi	r3,zero
	beq	copy_clut_fail
	stw	r3,current_clut_h(`bss)

**get r3=current table - each entry is 4 halfs
	bl	get_current_PmTable	*returns r3 pointing to Gdevice PmTable
**now calc fade values array
	bl	get_clut
	li	r3,0
	mtlr	r29
	blr
copy_clut_fail:
	li	r3,-1
	mtlr	r29
	blr

***********************************************************************
get_current_PmTable:
	lwz	r3,main_device_h(`bss)
	lwz	r3,(r3)
	addi	r3,r3,GdPMap
	lwz	r3,(r3)	
	lwz	r3,(r3)		*its a handle, now pointer to GdPMap
	addi	r3,r3,PmTable
	lwz	r3,(r3)	
	lwz	r3,(r3)
	addi	r3,r3,word*2	*skip seed,flags and size
				*r3 now points to actual colour values (4 halfs each)
	blr
*********************************************************
**Get clut gets the current clut in current_clut_h
get_clut:
	lwz	r10,current_clut_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here
	subi	r10,r10,half
	li	r5,max_colours
	mtctr	r5		*our loop counter
cc:
**get values for current clut entry
	lhz	r5,(r3)
	lhz	r6,2(r3)
	lhz	r7,4(r3)
	lhz	r8,6(r3)	
	sthu	r5,half(r10)	*
	sthu	r6,half(r10)
	sthu	r7,half(r10)	*copy the current clut
	sthu	r8,half(r10)		
	addi	r3,r3,8		*point to next entry
	bdnz	cc
	blr

*********************************************************
**Loads a clut r3 from the resource fork
load_clut:
	mflr	r28
	mr	r4,r3
	li	r3,"cl"
	li	r5,16
	slw	r3,r3,r5
	li	r5,"ut"
	or	r3,r3,r5
	Xcall	GetResource	*handle in r3
	mtlr	r28
	blr

*********************************************************
**calc fade values - needs r3 pointing at current PmTable
**clut_to_fade_to needs to be set up with a handle of the new clut
calc_fades_clut:
	lwz	r4,fade_values_h(`bss)
	lwz	r4,(r4)		*into our array of fade values  -r,g,b,r,g,b,r,g,b,etc
	lwz	r10,clut_copy_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here
	
	subi	r4,r4,half	*so we can use the update form of store
	subi	r10,r10,half
	lhz	r9,fade_steps(`bss)	*our divisor for calculating the fade value for rgb
	li	r5,max_colours
	mtctr	r5		*our loop counter
	lwz	r11,clut_to_fade_to(`bss)	
	lwz	r11,(r11)
calc_fadec_loop:
**get values for current clut entry
	lhz	r5,(r3)
	lhz	r6,2(r3)
	lhz	r7,4(r3)
	lhz	r8,6(r3)
	
	sthu	r5,half(r10)	*
	sthu	r6,half(r10)
	sthu	r7,half(r10)	*copy the current clut
	sthu	r8,half(r10)
		
	addi	r3,r3,8		*point to next entry

	lhz	r12,2(r11)	*get new red
	lhz	r13,4(r11)	*get new green
	lhz	r14,6(r11)	*get new blue
	addi	r11,r11,8
	
**now subtract the old colours from the new colours to get the change
	sub	r12,r12,r6
	sub	r13,r13,r7
	sub	r14,r14,r8	
**now divide each rgb by steps to get fade value for that value
	divw	r12,r12,r9
	divw	r13,r13,r9
	divw	r14,r14,r9
	sthu	r12,half(r4)	
	sthu	r13,half(r4)
	sthu	r14,half(r4)	*store fade values in array
	bdnz	calc_fadec_loop
	blr
		
*********************************************************
**calc fade values - needs r3 pointing at current PmTable
calc_fades:
	lwz	r4,fade_values_h(`bss)
	lwz	r4,(r4)		*into our array of fade values  -r,g,b,r,g,b,r,g,b,etc
	lwz	r10,clut_copy_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here
	
	subi	r4,r4,half	*so we can use the update form of store
	subi	r10,r10,half
	lhz	r9,fade_steps(`bss)	*our divisor for calculating the fade value for rgb
	li	r5,max_colours
	mtctr	r5		*our loop counter
	
calc_fade_loop:
**get values for current clut entry
	lhz	r5,(r3)
	lhz	r6,2(r3)
	lhz	r7,4(r3)
	lhz	r8,6(r3)
	
	sthu	r5,half(r10)	*
	sthu	r6,half(r10)
	sthu	r7,half(r10)	*copy the current clut
	sthu	r8,half(r10)
		
	addi	r3,r3,8		*point to next entry
**now divide each rgb by steps to get fade value for that value
	divw	r6,r6,r9
	divw	r7,r7,r9
	divw	r8,r8,r9
	sthu	r6,half(r4)	
	sthu	r7,half(r4)
	sthu	r8,half(r4)	*store fade values in array
	bdnz	calc_fade_loop
	blr

*********************************************************
**calc fades colour - needs r3 pointing at current PmTable
calc_fades_colour:
	lwz	r4,fade_values_h(`bss)
	lwz	r4,(r4)		*into our array of fade values  -r,g,b,r,g,b,r,g,b,etc
	lwz	r10,clut_copy_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here
	
	subi	r4,r4,half	*so we can use the update form of store
	subi	r10,r10,half
	lhz	r9,fade_steps(`bss)	*our divisor for calculating the fade value for rgb
	li	r5,max_colours
	mtctr	r5		*our loop counter
	
calc_fade_loopc:
**get values for current clut entry
	lhz	r5,(r3)
	lhz	r6,2(r3)
	lhz	r7,4(r3)
	lhz	r8,6(r3)
	
	sthu	r5,half(r10)	*
	sthu	r6,half(r10)
	sthu	r7,half(r10)	*copy the current clut
	sthu	r8,half(r10)
		
	addi	r3,r3,8		*point to next entry
**now divide each rgb by steps to get fade value for that value
	lhz	r11,fade_to_red(`bss)
	lhz	r12,fade_to_green(`bss)
	lhz	r13,fade_to_blue(`bss)

	sub	r6,r6,r11
	sub	r7,r7,r12
	sub	r8,r8,r13
		
	divw	r6,r6,r9
	divw	r7,r7,r9
	divw	r8,r8,r9

	sthu	r6,half(r4)	
	sthu	r7,half(r4)
	sthu	r8,half(r4)	*store fade values in array
	bdnz	calc_fade_loopc
	blr

************************************************************
**now run fade
**we subtract the relevent fade value from the copy of the clut, then set the 
**new clut.
run_fade:
	mflr	r28
	lhz	r3,fade_steps(`bss)
	sth	r3,fade_counter(`bss)
	
fade_step:
	li	r5,max_colours
	mtctr	r5		*our loop counter
	lwz	r4,fade_values_h(`bss)
	lwz	r4,(r4)		*into our array of fade values  -r,g,b,r,g,b,r,g,b,etc
	lwz	r10,clut_copy_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here - t,r,g,b,t,r,g,b,etc
	
	subi	r4,r4,half	*so we can use the update form of store
fade_clut_entry:
	lhzu	r6,half(r4)	*fade value
	lhz	r7,2(r10)	*get red
	sub	r7,r7,r6	*dec red by fade
	sth	r7,2(r10)	*save new red

	lhzu	r6,half(r4)	*fade value
	lhz	r7,4(r10)	*get green
	sub	r7,r7,r6	*dec green by fade
	sth	r7,4(r10)	*save new green

	lhzu	r6,half(r4)	*fade value
	lhz	r7,6(r10)	*get blue
	sub	r7,r7,r6	*dec blue by fade
	sth	r7,6(r10)	*save new blue
	
	addi	r10,r10,8	*point to next clut entry

	bdnz	fade_clut_entry		*do all 256 entries
	
	lwz	r3,clut_copy_h(`bss)
	lwz	r3,(r3)		*splat clut expects new clut in r3

	bl	splat_clut	*send clut to gdevice

	lhz	r3,fade_counter(`bss)	*check step counter
	subi	r3,r3,1
	sth	r3,fade_counter(`bss)
	cmpwi	r3,zero
	bne	fade_step
	mtlr	r28
	blr
	
**now run fade - used for fade to clut where the order of the maths is inmportant
**we add the relevent fade value from the copy of the clut, then set the 
**new clut.
run_fade_add:
	mflr	r28
	lhz	r3,fade_steps(`bss)
	sth	r3,fade_counter(`bss)
	
fade_step1:
	li	r5,max_colours
	mtctr	r5		*our loop counter
	lwz	r4,fade_values_h(`bss)
	lwz	r4,(r4)		*into our array of fade values  -r,g,b,r,g,b,r,g,b,etc
	lwz	r10,clut_copy_h(`bss)
	lwz	r10,(r10)	*we copy the current clut to here - t,r,g,b,t,r,g,b,etc
	
	subi	r4,r4,half	*so we can use the update form of store
fade_clut_entry1:
	lhzu	r6,half(r4)	*fade value
	lhz	r7,2(r10)	*get red
	add	r7,r7,r6	*dec red by fade
	sth	r7,2(r10)	*save new red

	lhzu	r6,half(r4)	*fade value
	lhz	r7,4(r10)	*get green
	add	r7,r7,r6	*dec green by fade
	sth	r7,4(r10)	*save new green

	lhzu	r6,half(r4)	*fade value
	lhz	r7,6(r10)	*get blue
	add	r7,r7,r6	*dec blue by fade
	sth	r7,6(r10)	*save new blue
	
	addi	r10,r10,8	*point to next clut entry

	bdnz	fade_clut_entry1		*do all 256 entries
	
	lwz	r3,clut_copy_h(`bss)
	lwz	r3,(r3)		*splat clut expects new clut in r3

	bl	splat_clut	*send clut to gdevice

	lhz	r3,fade_counter(`bss)	*check step counter
	subi	r3,r3,1
	sth	r3,fade_counter(`bss)
	cmpwi	r3,zero
	bne	fade_step1
	mtlr	r28
	blr

***********************************************************
*Misc clut routines follow                                *
***********************************************************
**Needs r3 pointing at new clut to splat to GDevice
splat_clut:		
	mflr	r27
	mr	r5,r3	*third param is pointer to new clut
	li	r3,0
	li	r4,255	*256 entries
	Xcall	SetEntries	*can take a long time...
	
	mtlr	r27
	blr

**Needs r3 pointing at source clut, and r4 pointing at dest clut
copy_clut:
	li	r5,max_colours
	mtctr	r5
	subi	r3,r3,half
	subi	r4,r4,half
cc_loop:	
	lhzu	r5,2(r3)	*could use fpu...
	lhzu	r6,2(r3)
	lhzu	r7,2(r3)
	lhzu	r8,2(r3)
	
	sthu	r5,2(r4)
	sthu	r6,2(r4)
	sthu	r7,2(r4)
	sthu	r8,2(r4)
	bdnz	cc_loop
	blr
**Needs r3 pointing to the clut to rotate	
**each entry is 8 bytes
rotate_clut:
**skip first entry
	addi	r3,r3,8
**save first entry
	lwz	r11,(r3)
	lwz	r12,4(r3)
**make r4 point to next entry
	mr	r4,r3
	addi	r4,r4,8
**now copy 1 to 0, 2 to 1 etc
	li	r5,max_colours-2	*-1 for bdnz and -1 again for the first entry
	mtctr	r5		*loop counter	
	subi	r3,r3,word
	subi	r4,r4,word
rc_loop:
	lwzu	r5,4(r4)	*copy 8 bytes
	stwu	r5,4(r3)
	lwzu	r5,4(r4)
	stwu	r5,4(r3)
	bdnz	rc_loop
**finally store the first entry in the last
	stw	r11,-4(r4)
	stw	r12,0(r4)
	blr
	
************************************************************
	global	fade_down,fade_to_colour,copy_active_clut,splat_clut
	global	copy_clut,rotate_clut,load_clut,fade_to_clut
	